diff --git a/gnu/packages/maths.scm b/gnu/packages/maths.scm
index 33eb4cda7b..47dc63bcec 100644
--- a/gnu/packages/maths.scm
+++ b/gnu/packages/maths.scm
@@ -5215,24 +5215,25 @@ (define-public scotch
      (list flex bison gfortran))
     (outputs '("out" "metis"))
     (arguments
-     `(#:configure-flags '("-DBUILD_SHARED_LIBS=YES" "-DINTSIZE=64"
-                           "-DBUILD_PTSCOTCH=OFF")
-       #:phases
-       (modify-phases %standard-phases
-         (add-after 'install 'install-metis
-           (lambda* (#:key outputs #:allow-other-keys)
-             ;; Move the METIS compatibility library to a separate output to
-             ;; avoid a name clash on <metis.h>.
-             (let* ((out    (assoc-ref outputs "out"))
-                    (metis  (assoc-ref outputs "metis"))
-                    (prefix (string-length out)))
-               (for-each (lambda (file)
-                           (let ((target (string-append
-                                          metis
-                                          (string-drop file prefix))))
-                             (mkdir-p (dirname target))
-                             (rename-file file target)))
-                         (find-files out "metis"))))))))
+     (list #:configure-flags #~'("-DBUILD_SHARED_LIBS=YES" "-DINTSIZE=64"
+                                 "-DBUILD_PTSCOTCH=OFF")
+           #:phases
+           #~(modify-phases %standard-phases
+               (add-after 'install 'install-metis
+                 (lambda* (#:key outputs #:allow-other-keys)
+                   ;; Move the METIS compatibility library to a separate output to
+                   ;; avoid a name clash on <metis.h>.
+                   (let* ((out (assoc-ref outputs "out"))
+                          (metis (assoc-ref outputs "metis"))
+                          (prefix (string-length out)))
+                     (for-each (lambda (file)
+                                 (let ((target
+                                        (string-append metis
+                                                       (string-drop file
+                                                                    prefix))))
+                                   (mkdir-p (dirname target))
+                                   (rename-file file target)))
+                               (find-files out "metis"))))))))
     (home-page "https://www.labri.fr/perso/pelegrin/scotch/")
     (properties
      `((release-monitoring-url
@@ -5256,9 +5257,8 @@ (define-public scotch32
     (name "scotch32")
     (arguments
      (substitute-keyword-arguments (package-arguments scotch)
-       ((#:configure-flags flags ''())
-        ''("-DBUILD_SHARED_LIBS=YES" "-DBUILD_PTSCOTCH=OFF"
-           "-DINTSIZE=32"))))
+       ((#:configure-flags flags #~'())
+        #~'("-DBUILD_SHARED_LIBS=YES" "-DBUILD_PTSCOTCH=OFF" "-DINTSIZE=32"))))
     (synopsis
      "Programs and libraries for graph algorithms (32-bit integers)")))
 
@@ -5270,13 +5270,12 @@ (define-public pt-scotch
      (list openmpi))                              ;headers include MPI headers
     (arguments
      (substitute-keyword-arguments (package-arguments scotch)
-       ((#:configure-flags flags ''())
-        ''("-DBUILD_SHARED_LIBS=YES" "-DBUILD_PTSCOTCH=ON"
-           "-DINTSIZE=64"))
-       ((#:phases phases '%standard-phases)
-        `(modify-phases ,phases
-           (add-before 'check 'mpi-setup
-             ,%openmpi-setup)))))
+       ((#:configure-flags flags #~'())
+        #~'("-DBUILD_SHARED_LIBS=YES" "-DBUILD_PTSCOTCH=ON" "-DINTSIZE=64"))
+       ((#:phases phases #~%standard-phases)
+        #~(modify-phases #$phases
+            (add-before 'check 'mpi-setup
+              #$%openmpi-setup)))))
     (synopsis "Programs and libraries for graph algorithms (with MPI)")))
 
 (define-public pt-scotch32
@@ -5287,9 +5286,8 @@ (define-public pt-scotch32
      (list openmpi))                     ;headers include MPI headers
     (arguments
      (substitute-keyword-arguments (package-arguments pt-scotch)
-       ((#:configure-flags flags ''())
-        ''("-DBUILD_SHARED_LIBS=YES" "-DBUILD_PTSCOTCH=ON"
-           "-DINTSIZE=32"))))
+       ((#:configure-flags flags #~'())
+        #~'("-DBUILD_SHARED_LIBS=YES" "-DBUILD_PTSCOTCH=ON" "-DINTSIZE=32"))))
     (synopsis
      "Programs and libraries for graph algorithms (with MPI and 32-bit integers)")))
 